package org.greenstone.gsdl3.gs3build;

import java.util.List;
import java.util.ArrayList;

public class Build
{
  BuildManager manager;

  public Build(List inputRoots, String collection, String outputDir)
  { this.manager = new BuildManager(inputRoots, collection, outputDir);
  }

  public void run()
  { this.manager.run();
  }

  public static void main(String args[])
  { int a = 0;
    List inputDirs = new ArrayList();
    String collection = null;
    String outputDir  = null;

    while (a < args.length)
    { System.out.println(args[a]);
      if (args[a].equals("-inputdir")) {
	if (a < args.length - 1 &&
	    args[a+1].charAt(0) != '-')
	{
	  inputDirs.add(args[a+1]);
	  a ++;	
	}
      }
      else if (args[a].equals("-collect")) {
	if (a < args.length - 1 &&
	    args[a+1].charAt(0) != '-')
	{
	  collection = args[a+1];
	  a ++;
	}
      }
      else if (args[a].equals("-outputDir")) {
	if (a < args.length - 1 &&
	    args[a+1].charAt(0) != '-')
	{ outputDir = args[a+1];
	  a ++;
	}
      }
      a ++;
    }

    if (collection == null && inputDirs.size() == 0)
    { System.err.println("At least one input directory must be given, or a collection name");
      System.exit(0);
    }

    Build build = new Build(inputDirs, collection, outputDir);
    build.run();

    return;
  }
}
