package org.greenstone.gsdl3.util;


import org.xml.sax.InputSource;
import org.xml.sax.EntityResolver;
import java.io.File;
import java.net.URL;

// uses a class loader to find entities
public class GSEntityResolver implements EntityResolver {

    public InputSource resolveEntity (String public_id, String system_id) {
	
	System.out.println("entity resolver for "+system_id);
	String temp_id = system_id;
	if (temp_id.startsWith("file://")) {
	    File f = new File(system_id);
	    if (f.exists()) {
		return new InputSource(system_id);
	    } else {
		temp_id = temp_id.substring(temp_id.lastIndexOf(File.separator)+1);
	    }
	} else {
	    if (temp_id.indexOf(File.separatorChar)!= -1) {
		temp_id = temp_id.substring(temp_id.lastIndexOf(File.separator)+1);
	    }
	}
	
	System.out.println("using class loader for "+temp_id);
	URL url = ClassLoader.getSystemResource(temp_id);
	if (url == null) {
	    System.out.println("class loader didn't find it");
	    return null;
	}
	return new InputSource("file://"+url.getFile());
    }

}
