#!/bin/bash -v

#check that GSDL3HOME is set
if test -z "$GSDL3HOME" ; then
  echo "You need to 'source setup.bash' before running the update script"
 exit;
fi

#make sure we have the current GSDL3
cvs update -dRP

# make mgpp
cd packages/mgpp
make
make install
CLASSPATH=$GSDL3HOME/lib/java/mgpp.jar:$CLASSPATH
cd $GSDL3HOME

# make mg
cd packages/mg
make
make install
CLASSPATH=$GSDL3HOME/lib/java/mg.jar:$CLASSPATH
cd $GSDL3HOME

# make the java packages
cd src/java/org/greenstone/gdbm
make clean
make
make install
CLASSPATH=$GSDL3HOME/lib/java/gdbm.jar:$CLASSPATH
cd $GSDL3HOME

cd src/java/org/greenstone/testing
make clean
make
make install
CLASSPATH=$GSDL3HOME/lib/java/jutest.jar:$CLASSPATH
cd $GSDL3HOME

cd src/java/org/greenstone/gsdl3
make clean
make
make install
CLASSPATH=$GSDL3HOME/lib/java/gsdl3.jar:$CLASSPATH
cd $GSDL3HOME

cd src/java/org/greenstone/applet/phind
make clean
make
make install
CLASSPATH=$GSDL3HOME/lib/java/Phind.jar:$CLASSPATH
cd $GSDL3HOME

# make the javadocs
JAVADOCDIR=$GSDL3HOME/docs/javadoc
mkdir -p $JAVADOCDIR
javadoc -d $JAVADOCDIR -private  -link http://java.sun.com/j2se/1.4.2/docs/api/ `find src -name '*.java'` `find packages/ -name '*.java'` > $JAVADOCDIR/javadoc_log


#compile the test servlet
cd web/WEB-INF/classes
javac TestServlet.java
cd $GSDL3HOME


#start tomcat - i dont think install should start up tomcat
#comms/jakarta/tomcat/bin/shutdown.sh
#comms/jakarta/tomcat/bin/startup.sh

#NOTE: if you recompile anything, you need to shutdown and restart tomcat
#to shutdown:
#comms/jakarta/tomcat/bin/shutdown.sh
#to startup:
#comms/jakarta/tomcat/bin/startup.sh




